      program msusix2
c ... reformat msu 1-b data for input to program 'toving'
c ... version of 24.10.94 ... for direct-access input file

      include 'rfac.inc'
      
c ... parameters ..
      integer nbi,nbx,nwi,nwo,leno
      parameter (nbi=437,nbx=nbi+3,nwi=nbx/4,nwo=100,leno=nwo*4)
c ...
c ... local scalars ..
      real hour
      integer i,id,im,inst,isatn,ium,iut,iy,iyd,jd,jtype,jy,lines,msec,
     +        nlo,nri,nro,nsat
      character*4 cmon
      character*8 cunk,time
      character*12 date,mfile,tfile
c ...
c ... local arrays ..
      integer ibuf(nwo),ihdr(nwo),jbuf(nwi)
      byte kbuf(nbx)
      character*4 cins(0:2)
      character*8 csat(0:14)
c ...
c ... external functions ..
      integer lbyte,nsat1b
      external lbyte,nsat1b
c ...
c ... external subroutines ..
      external calday,ctime
c ...
c ... intrinsic functions ..
      intrinsic float,mod
c ...
c ... equivalences ..
      equivalence (kbuf(1),jbuf(1))
c ...
c ... data statements ..
      data cins/'unkn','hirs','msu'/
      data csat/5*' ','tiros-n','noaa-6','noaa-7','noaa-8','noaa-9',
     +     'noaa-10','noaa-11','noaa-12','noaa-13','noaa-14'/
      data cunk/'unknown'/
      data mfile/'msusibin.dat'/,ium/20/
      data tfile/'msustape.dat'/,iut/10/
c ...
 
      csat(0) = cunk
c ...
      open (iut,file=tfile,recl=nbi/rfac,
     &      access='direct',status='old')
      open (ium,file=mfile,recl=leno/rfac,
     &      access='direct',status='unknown')
c ... read and save tape-file header record.
      nri = 1
      read (iut,rec=nri,err=190) (kbuf(i),i=1,nbi)
      call swap32(jbuf,nwi)
c      isatn = kbuf(1)
      isatn = kbuf(4)
      if (isatn.eq.0) then
        write (*,fmt=
     +    '('' unable to extract satellite id from header.'')')
        go to 200
      end if
      do 100 i = 1,nwo
  100 ihdr(i) = jbuf(i)
c ... display some information from that record.
      jy = lbyte(17,7,jbuf)
      nsat = nsat1b(isatn,jy)
c      jtype = kbuf(2)
      jtype = kbuf(3)
      inst = (jtype-81)/16 + 1
      if (inst.lt.2) inst = 0
      lines = lbyte(65,16,jbuf)
      write (*,fmt=110) jtype,cins(inst),isatn,csat(nsat),lines
  110 format (' data type = ',i2,' => ',a4,', s/c id = ',i1,' => ',a8,
     +       '... no.lines = ',i3)
      if (inst.eq.0 .or. nsat.eq.1) go to 200
c ... put number of *data* records in last word of first (header) record.
      ihdr(nwo) = lines
      nro = 1
      write (ium,rec=nro) ihdr
      nlo = 0
c ...
  120 continue
      nri = nri + 1
      read (iut,rec=nri,err=160) (kbuf(i),i=1,nbi)
      call swap32(jbuf,nwi)
      if (jbuf(1).eq.0) go to 160
      do 130 i = 1,nwo
  130 ibuf(i) = jbuf(i)
      nro = nro + 1
      write (ium,rec=nro) ibuf
      nlo = nlo + 1
      if (mod(nlo,25).eq.1) then
        msec = lbyte(38,27,jbuf)
        hour = float(msec)/3600000.
        jy = lbyte(17,7,jbuf)
        jd = lbyte(24,9,jbuf)
        iyd = 1000*jy + jd
        call calday(iyd,iy,im,id,cmon)
        write (date,fmt=140) id,cmon,iy
  140   format (i2.2,1x,a4,'19',i2)
        call ctime(hour,time)
        write (*,fmt=150) nlo,date,time
  150   format (' line ',i3,' ... ',a12,a8)
      end if
      if (nlo.lt.lines) go to 120
c ...
  160 close (iut)
      write (*,fmt=170) nlo
  170 format (' no.lines written = ',i3)
      if (nlo.lt.lines) then
        ihdr(nwo) = nlo
        nro = 1
        write (ium,rec=nro) ihdr
      end if
      close (ium)
      go to 200
c ...
  190 write (*,fmt='('' *** error reading hdr record of file '',a12)')
     +  tfile
  200 stop
      end
