      program tovinw2
c ... global version of 28.04.95
c ... ingest' (apply calibration and earth-location parameters to)
c ... tovs (hirs and msu) 'level 1-b' data

      include 'rfac.inc'
      
c ... parameters ..
      integer lenh,lenm,lent
      parameter (lenh=4*961,lenm=4*100,lent=4*112)
c ...
c ... scalars in common ..
      character*4 ctype
c ...
c ... local scalars ..
      integer idsh,idsm,iuh,ium,nuh,num,itype
      character*12 hfili,hfilo,mfili,mfilo
c ...
c ... local arrays ..
      character*8 csat(14)
c ...
c ... external subroutines ..
      external hirinw,msuinw
c ...
c ... common blocks ..
      common /cfdb/ctype
c ...
c ... data statements ..
      data csat/4*' ','tiros-n','noaa-6','noaa-7','noaa-8','noaa-9',
     +     'noaa-10','noaa-11','noaa-12','noaa-13','noaa-14'/
      data hfili/'hirsibin.dat'/,mfili/'msusibin.dat'/
      data hfilo/'hirsingo.dat'/,mfilo/'msusingo.dat'/
      data iuh/11/,ium/12/,nuh/21/,num/22/
c ...
      write(*,'(''limb/lwflux correction coefficient database'',
     +     '' (1=tigr,2=p12s): '',$)')
      read (*,fmt=*) itype
      ctype = 'xxxx'
      if (itype.eq.1) then
        ctype = 'tigr'
      elseif (itype.eq.2) then
        ctype = 'p12s'
      else
        write (*,fmt=*) 
     +        'error: invalid coefficient type selected in tovinw'
        stop
      endif
c ... 
      open (iuh,file=hfili,access='direct',recl=lenh/rfac,
     &      status='old')
      open (ium,file=mfili,access='direct',recl=lenm/rfac,
     &      status='old')
      open (nuh,file=hfilo,access='direct',recl=lent/rfac,
     &      status='unknown')
      open (num,file=mfilo,access='direct',recl=lent/rfac,
     &      status='unknown')
c ...     
      call hirinw2(iuh,nuh,idsh)
      close (iuh)
      close (nuh)
      call msuinw2(ium,num,idsm)
      close (ium)
      close (num)
c ...
      if (idsm.ne.idsh) then
        write (*,fmt='(/'' hirs is from '',a8)') csat(idsh)
        write (*,fmt='(''  msu is from '',a8)') csat(idsm)
        write (*,fmt='(''  *** check input data files!'')')
        stop ' *** hirs/msu satellite mismatch! *** '
      else
        write (*,fmt='(/'' tovs 1-b ingest done for '',a8)') csat(idsh)
      end if
c ...      
      end
