      program tovprw2
c ... global version of 28.04.95
c ... preprocess tovs data: prepare output of either direct-readout
c ... ('ingtow') or level 1-b ('tovinw') ingest for input to tovrew.
c ... note: this version alows the user to select limb/lwflux correction
c ... coefficients from either the tigr or the p12s database.

c     Version 2  - runs on little endian computers
c                - Uses hirprw2.f with updated error checks
c                - Uses msuprw2.f

      include 'rfac.inc'
      
c ... parameters ..
      integer leni,leno,lens,mdis
      parameter (leni=448,leno=448,lens=480,mdis=3)
c ...
c ... scalars in common ..
      integer lchoff,lcmoff
      character nfile
      character*4 ctype
c ...
c ... local scalars ..
      integer iuh,ium,iuo,ius,lcoeff,linmax,lonfix,noflip,itype
      character*4 ctigr
      character*12 hirsin,msusin,orbout,sndout
c ...
c ... external subroutines ..
      external fixllw,hirprw2,msuprw,prelow,soundw
c ...
c ... common blocks ..
      common /cfdb/ctype
      common /nohlc/lchoff
      common /nomlc/lcmoff
      common /point/nfile
c ...
c ... data statements ..
      data ctigr/'tigr'/
      data iuh/20/,ium/21/,iuo/22/,ius/23/
      data hirsin/'hirsingo.dat'/
      data msusin/'msusingo.dat'/
      data orbout/'tovsorb .dat'/
      data sndout/'tovssnd .dat'/
c ...
 
      write (*,fmt='('' enter letter of file for output: '',$)')
      read (*,fmt='(a1)') nfile
 
c ... select limb/lwflux correction coefficients

      write(*,'('' enter limb/lwflux correction coefficient'',
     +     '' database (1=tigr,2=p12s): '',$)')
      read (*,fmt=*) itype
      lcoeff = 0
      ctype = 'xxxx'
      if (itype.eq.1) then
        ctype = 'tigr'
        lcoeff = 1
      elseif (itype.eq.2) then
        ctype = 'p12s'
        lcoeff = 2
      else
        write (*,fmt=*) 
     +        'error: invalid coefficient type selected in tovprw'
        stop
      endif
 
c ... get user input
 
      write (*,fmt='('' cimss recommends limb-correction off ...'')')
      write (*,fmt=
     +  '('' enter hirs limb-correction flag (1=on,0=off): '',$)')
      read (*,fmt=*) lchoff
      lchoff = 1 - lchoff
      write (*,fmt=
     +  '('' enter  msu limb-correction flag (1=on,0=off): '',$)')
      read (*,fmt=*) lcmoff
      lcmoff = 1 - lcmoff
      write (*,fmt=
     +  '('' enter  image-rectification flag (1=on,0=off): '',$)')
      read (*,fmt=*) noflip
      noflip = 1 - noflip
      orbout(8:8) = nfile
      sndout(8:8) = nfile
c ...
      open (iuh,file=hirsin,access='direct',recl=leni/rfac,
     &      status='old')
      call prelow(iuh,linmax)
      if (linmax.eq.0) stop ' *** no hirs data! *** '
      open (ium,file=msusin,access='direct',recl=leni/rfac,
     &      status='old')
      call msuprw2(ium,lonfix)
      close (ium)
      open (iuo,file=orbout,access='direct',recl=leno/rfac,
     &      status='unknown')
      call hirprw2(iuh,iuo,linmax,mdis,lonfix,lcoeff,noflip)
      close (iuh)
      close (iuo)
      call fixllw()
      open (ius,file=sndout,access='direct',recl=lens/rfac,
     &      status='unknown')
      call soundw(ius)
      close (ius)
      write (*,fmt=
     +  '(/'' files  '',a12,''  and  '',a12,''  are ready.'')') orbout,
     +  sndout
      end
