      subroutine hirinw2(iu,nu,idsat)
c ... version of 07.05.92
c
c*    Updated with following features (6/22/98,dlj)
c     1. Includes data with jtype=83 (data downlinked to France).
c
c ... scalar arguments ..
      integer idsat,iu,nu
c ...
c ... local scalars ..
      double precision two22,two30,two44
      real alt,altnom,altsav,ang,counts,rads,sctime,sinzen,spacnt,spavg,
     +     test,viscon,x
      integer i,initms,initmt,irec,iyyddd,j,jb,jbyte,jch,jddd,jdispl,
     +        jhour,jmin,jnkodr,joff,jpos,jsat,jsec,jstart,jstop,jtype,
     +        jyd,jyear,jyyddd,ksat,lerrs,lersum,linco,line,lkalib,
     +        lnode,lset,ltflag,mfn,mtdif,mtime,mtlast,nbad,nch,nd,nm,
     +        nopos,nprs,nrec,nscans,nspac,nthday,ny
      logical badalt
      character*4 cmon
c ...
c ... local arrays ..
      real c0(20),c1(20),c2(20),cvis(14),r0(20),r1(20),r2(20),
     +     reason(20,2),satalt(2),ylats(56),ylons(56),zens(56)
      integer indat(961),jbuf(112),jdata(28),newpos(20)
c ...
c ... external functions ..
      real bright,xfloat
      integer lbit,lbyt16_pc,lbyte,lchar_pc,lngtst,mbyt16_pc,nsat1b
      external bright,xfloat,lbit,lbyt16_pc,lbyte,lchar_pc,lngtst,
     +         mbyt16_pc,nsat1b
c ...
c ... external subroutines ..
      external calday,move,pfcoef_pc
c ...
c ... intrinsic functions ..
      intrinsic abs,atan2,float,ior,mod,sign,sin,sqrt
c ...
c ... statement functions ..
      real arcsin,sine
c ...
c ... data statements ..
c ... longwave low
c ... shortwave low
c ... longwave high
c ... shortwave high
      data (cvis(i),i=1,4)/4*0./
      data cvis(5)/2.84547/
      data cvis(6)/7.6975/
      data cvis(7)/2.84547/
      data cvis(8)/4.696/
      data cvis(9)/4.56359/
      data (cvis(i),i=10,14)/5*4.6/
      data satalt/860.,820./,spavg/-3617./
      data newpos/1,17,2,3,13,4,18,11,19,7,8,20,10,14,6,5,15,12,16,9/
      data two22/4194304.d+0/
      data two30/1.0737418d+9/
      data two44/1.7592186d+13/
      data c0/20*0./,c1/20*0./,c2/20*0./
      data r0/20*0./,r1/20*0./,r2/20*0./
      data (reason(i,1),i=1,12)/7*15.,6.,3.5,1.,.5,.25/
      data (reason(i,1),i=13,20)/.003,3*.002,.001,.0004,.0001,0./
      data (reason(i,2),i=1,12)/5*120.,130.,145.,245.,100.,175.,2*50./
      data (reason(i,2),i=13,20)/7*10.,0./
c ...
c ... statement function definitions ..
 
      sine(x) = sin(.0174533*x)
      arcsin(x) = 57.29578*atan2(x,sqrt(1.-x*x))
c ...
c ...
c ... read header record
      write (*,fmt='(/'' begin global hirs 1-b ingest ... '')')
      irec = 1
      read (iu,rec=irec) indat
      jsat = lchar_pc(1,indat)
      jyear = lbyte(17,7,indat)
      idsat = nsat1b(jsat,jyear)
      if (idsat.eq.0) then
        write (*,fmt='('' *** unrecognized satellite ident '',i4)') jsat
        stop ' *** unrecognized satellite ident *** '
      else
        write (*,fmt='('' data source is satellite number '',i2)') idsat
      end if
      jtype = lchar_pc(2,indat)
      if (jtype.eq.81) go to 110
      if (jtype.eq.82) go to 110
      if (jtype.eq.83) go to 110
      write (*,fmt='('' *** unrecognized data type '',i3)') jtype
      stop ' *** unrecognized data type *** '
  110 altsav = 0.
      call pfcoef_pc(idsat)
      ksat = 2 - mod(idsat,2)
      altnom = satalt(ksat)
      viscon = cvis(idsat)
      mtlast = -6400000
c ... this value is large enough to insure that the program will
c ... not make a 'missing data' call on the first s.e.b.
      lersum = 0
c ... logical sum of all errors
      nopos = 0
c ... number of undefined encoder positions
      lkalib = 0
      joff = 0
c ... number of bad altitudes
      nbad = 0
c ... number of bad radiances
      nprs = 0

      nrec = 1
      jstart = .001*float(lbyte(38,27,indat)) + .5
      jyear = lbyte(17,7,indat)
      jddd = lbyte(24,9,indat)
      jyd = 1000*jyear + jddd
      call calday(jyd,ny,nm,nd,cmon)
      nscans = indat(961)
      jstop = .001*float(lbyte(102,27,indat)) + .5
      jhour = jstart/3600
      jmin = (jstart-3600*jhour)/60
      jsec = jstart - 3600*jhour - 60*jmin
      write (*,fmt=120) jhour,jmin,jsec,nd,cmon,ny,nscans
  120 format (' hirs starting time ',3i3,2x,i3,1x,a4,i3,i6,
     +       ' scan lines')
      jhour = jstop/3600
      jmin = (jstop-3600*jhour)/60
      jsec = jstop - 3600*jhour - 60*jmin
      write (*,fmt=130) jhour,jmin,jsec
  130 format (7x,' ending time ',3i3,/)
      spacnt = 0.
c ... space count accumulator for chan 20
      nspac = 0
c ... number of space looks in channel 20
c ... cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c ... outermost loop
      do 260 line = 1,nscans
        irec = irec + 1
        read (iu,rec=irec) indat
        lset = 2*lbit(65,indat) + lbit(82,indat)
c ...   tests for 'fatal' and 'synch error' conditions
        linco = lbyt16_pc(1,indat)
        jyear = lbyte(17,7,indat)
        nthday = lbyte(24,9,indat)
        jyyddd = 1000*jyear + nthday
        mtime = lbyte(38,27,indat)
c ...   time of day of start of scan in seconds
        sctime = .001*float(mtime)
c ...   altitude of s/c in kilometers
        alt = lbyt16_pc(369,indat)
        if (alt.lt.760. .or. alt.gt.920.) then
          badalt = .true.
          if (nbad.lt.20) write (*,fmt=135) alt,irec
  135     format ('  bad s/c altitude ',g12.5,' in record ',i4)
          nbad = nbad + 1
          if (altsav.ne.0.) then
c ...       replace bad altitude with last good value
            alt = altsav
          else
c ...       replace bad altitude with nominal value
            alt = altnom
          end if
        else
          badalt = .false.
        end if
        if (.not.badalt) altsav = alt
        if (line.eq.1) then
          iyyddd = jyyddd
          initmt = 64.*sctime + .5
          initms = mtime
        end if
c ...
        do 140 j = 1,56
          jb = 371 + 2* (j-1)
          ylats(j) = float(mbyt16_pc(jb,indat))/128.
          ylons(j) = float(mbyt16_pc(jb+1,indat))/128.
          ang = -49.5 + 1.8*float(j-1)
          sinzen = abs((alt+6371.)*sine(ang)/6371.)
          zens(j) = arcsin(sinzen)
  140   continue
        lnode = 1
        if (lngtst(ylons(1),ylons(28),ylons(56)).eq.0) lnode = -1
c ...   senses ascending or descending pass
        do 150 nch = 1,20
          jb = 249 + 6* (nch-1)
c ...
          jch = newpos(nch)
c ...     the counts are not in order of channel number.  the order is
c ...     given by the array 'newpos' - lauritsen, 9.03.79
          if (jch.eq.20) go to 150
c ...     get linearization coefficients, probably 0., 1., and 0.
          c0(jch) = xfloat(jb,indat)/two22
          c1(jch) = xfloat(jb+2,indat)/two30
          c2(jch) = xfloat(jb+4,indat)/two44
c ...     calib coefs
c ...     note that the linearization and calibration coefficients are
c ...     not given in the same order on the tape.
          jb = jb - 120
          r2(jch) = xfloat(jb,indat)/two44
          r1(jch) = xfloat(jb+2,indat)/two30
          r0(jch) = xfloat(jb+4,indat)/two22
          if (jch.gt.2) go to 150
          if (idsat.eq.5) go to 150
          if (idsat.eq.9) go to 150
c          if (idsat.eq.11) go to 150 
          if (jch.eq.2) then
            if (idsat.ne.12) go to 150
            test = abs(r0(2))
c            if (test.ge.250.) go to 150
            if (test.ge.200.) go to 150
            test = test + 512.
            r0(2) = sign(test,r0(2))
            go to 150
          end if
          test = abs(r0(1))
          if (idsat.ne.12) then
c            if (test.ge.250.) go to 150
            if (test.ge.200.) go to 150
            test = test + 512.
            r0(1) = sign(test,r0(1))
            go to 150
          end if
          if (test.lt.200.) then
            test = test + 2048.
          else
            test = test + 1536.
          end if
          r0(1) = sign(test,r0(1))
  150   continue
        do 250 jpos = 1,56
          lerrs = lset
          mfn = jpos - 1
          call move(0,0,jdata,1,28)
          jbyte = 965 + 44* (jpos-1)
          jnkodr = lchar_pc(jbyte,indat)
          if (jnkodr.ge.68) go to 180
          if (mfn.ge.4 .or. jnkodr.eq.jpos) go to 190
c ...     when beginning auto-calib, the encoder is 4 mfn's late getting
c ...     to encoder position 68.  the preceding test checks for this
c ...     condition.
  160     lerrs = ior(lerrs,32)
          lkalib = 1
          if (jnkodr.eq.68) go to 170
          if (nspac.eq.0) go to 220
          spavg = spacnt/float(nspac)
          nspac = 0
          spacnt = 0.
          go to 220
c ...     accumulate chan 20 counts from space.
  170     jb = 22*mfn + 496
c ...     chan 20 is in 12th position.
          spacnt = spacnt + float(mbyt16_pc(jb,indat))
          nspac = nspac + 1
          go to 220
  180     if (jnkodr.eq.68 .or. jnkodr.eq.105 .or.
     +        jnkodr.eq.156) go to 160
          nopos = nopos + 1
          go to 250
c ...     this is a normal earth view.
  190     continue
          jdispl = 22*mfn + 484
c ...     the data for each of the 56 encoder positions takes 44 bytes or
c ...     half-words.  this information is preceded by 484 half-words.
c ...     now convert linearized counts to radiance.
          do 210 nch = 1,20
            jb = jdispl + nch
            jch = newpos(nch)
            if (jch.eq.20) go to 210
            counts = mbyt16_pc(jb,indat)
            counts = c0(jch) + counts* (c1(jch)+counts*c2(jch))
            rads = r0(jch) + counts* (r1(jch)+counts*r2(jch))
            if (rads.ge.reason(jch,1) .and.
     +          rads.le.reason(jch,2)) go to 200
            nprs = nprs + 1
            if (nprs.gt.20) go to 210
            write (*,fmt=
     +'('' bad counts and/or radiance in chan'',i3,1x,           2e16.6)
     +') jch,counts,rads
            go to 210
  200       jdata(jch+1) = 100.*bright(rads,jch) + .5
  210     continue
c ...     pack line and spot nos. into one word (16 bits each).
  220     jdata(1) = 65536*linco + mfn + 1
          jdata(26) = jyyddd
          jdata(27) = 64.* (sctime+.1*float(mfn)) + .5
          ltflag = 0
          mtdif = jdata(27) - mtlast
          if (jpos.eq.1 .and. mtdif.gt.95) ltflag = 128
          if (jpos.gt.1 .and. mtdif.gt.9) ltflag = 128
          lerrs = ior(lerrs,ltflag)
c ...     these tests detect missing data preceding this scan position.
c ...     the time unit used in these tests is 64ths of a second.
          mtlast = jdata(27)
          jdata(22) = 100.*ylats(jpos) + sign(.5,ylats(jpos))
          jdata(23) = 100.*ylons(jpos) + sign(.5,ylons(jpos))
          jdata(24) = 100.*zens(jpos) + sign(.5,zens(jpos))
          jdata(25) = lerrs
c
          jb = 22*mfn + 496
          jdata(21) = 0
          if (jnkodr.le.56 .and. abs(spavg).gt.0.) jdata(21) = viscon*
     +        (float(mbyt16_pc(jb,indat))-spavg)
c ...     visible channel counts
          lersum = ior(lersum,lerrs)
          do 230 j = 1,28
  230     jbuf(j+joff) = jdata(j)
          joff = joff + 28
          if (joff.ne.112) go to 250
          nrec = nrec + 1
          write (nu,rec=nrec) jbuf
          joff = 0
  250   continue
        if (mod(line,100).ne.0) go to 260
        write (*,fmt='('' finished line '',i4)') line
  260 continue
c ... end of data-processing loop
c ...
c ... construct and write header record
      jdata(1) = idsat
      jdata(2) = nrec - 1
      jdata(3) = lnode
      jdata(4) = initmt
c ... starting time in 64ths secs
      jdata(5) = iyyddd
      jdata(6) = mtlast
c ... ending time in 64ths secs
      jdata(7) = jyyddd
      jdata(8) = lkalib
      jdata(9) = lersum
      jdata(10) = 0
      jdata(11) = nscans
      jdata(12) = nopos
      jdata(13) = initms
c ... starting time in milliseconds
      call move(0,0,jbuf,1,112)
      call move(jdata,1,jbuf,1,13)
      write (nu,rec=1) jbuf
      write (*,fmt=270) nscans,nrec,nprs,nbad,nopos
  270 format (' hirs ingest complete:',i5,' scan lines, last record = ',
     +       i6,/,'  no.bad radiances = ',i6,/,'  no.bad altitudes = ',
     +       i6,/,'  no.bad encdr-pos = ',i6)

      return
      end
