      subroutine hirlc2(jbuf,isat,init)
c ... version of 26.04.95
c ... note: limb-correction must be done in order for lwflux to give
c ... proper results.  if switch is off (lchoff.ne.0), original
c ... tbb's are restored for output.
c ... parameters ..
c
c     version 2 uses little endian machine
c
      integer m,n,mx,nx,nc,nw,ni,nk
      parameter (m=8,n=m+1,mx=17,nx=mx+1,nc=19,nw=3,ni=nc+1,nk=7)
      integer nlin,npos,npar
      parameter (nlin=2,npos=56,npar=30)
c ...
c ... scalar arguments ..
      integer init,isat
c ...
c ... array arguments ..
      integer jbuf(npos,nlin,npar)
c ...
c ... scalars in common ..
      integer lchoff
c ...
c ... arrays in common ..
      real cofa(n,nc,nk),cofw(n,nw)
      integer indx(m,ni)
c ...
c ... local scalars ..
      real btem1,sum
      integer i,indv,ipos,iszn,itc4,ix,izen,j,jlin,k,l,misg,nite
      logical cold,dry,window
c ...
c ... local arrays ..
      real btem(nc),c(nc),ctem(nc),cw(nw),xtem(nx)
      integer indw(nw),item(nc),itsol(nw)
c ...
c ... external functions ..
      integer irefls,lwflux
      external irefls,lwflux
c ...
c ... external subroutines ..
      external rdhlcf_pc
c ...
c ... intrinsic functions ..
      intrinsic abs,amax1,cos,float
c ...
c ... common blocks ..
      common /hirlim/cofa,cofw,indx
      common /nohlc/lchoff
c ...
c ... statement functions ..
      real secant
c ...
c ... data statements ..
      data nite/9000/,misg/999999/
      data indw/8,18,19/,indv/20/
c ...
c ... statement function definitions ..
 
      secant(i) = 1./cos(.0001745329*float(i))
c ...
c ...
      if (isat.ne.init) then
        call rdhlcf_pc(isat)
        init = isat
      end if
c ...
      do 120 jlin = 1,nlin
        do 110 ipos = 1,npos
          do i = 1,nc
            item(i) = jbuf(ipos,jlin,i+3)
            if (item(i).eq.misg) then
              jbuf(ipos,jlin,25) = misg
              go to 110
            end if
          end do
          izen = jbuf(ipos,jlin,25)
          do i = 1,nc
            btem(i) = .01*float(item(i))
c ...       save a copy of the original data
            ctem(i) = btem(i)
          end do
          if (isat.lt.11 .or. isat.eq.12) then
            btem1 = .5* (btem(2)+btem(17))
            if (abs(btem(1)-btem1).gt.5.) then
              btem(1) = btem1
              ctem(1) = btem1
            end if
          end if
          cold = btem(8) .lt. 265.
          dry = abs(btem(8)-btem(10)) .lt. 3.
          l = ipos
          if (l.lt.29) then
            k = 29 - l
          else
            k = l - 28
          end if
          xtem(nx) = secant(izen)
          do i = 1,mx
            xtem(i) = btem(i)*xtem(nx)
          end do
          k = (k-1)/4 + 1
          do j = 1,nc
            window = j .eq. 8 .or. j .eq. 18 .or. j .eq. 19
            sum = 0.
            if (.not. (window.and.cold)) then
              do i = 1,m
                ix = indx(i,j)
                if (ix.ne.0) then
                  sum = sum + cofa(i,j,k)*xtem(ix)
                end if
              end do
              sum = sum + cofa(n,j,k)
            end if
            c(j) = sum
          end do
          if (dry) then
            c(8) = 0.
            c(10) = 0.
            c(11) = 0.
            c(18) = 0.
            c(19) = 0.
          end if
          do j = 1,nc
            btem(j) = btem(j) + c(j)
          end do
          if (.not. (cold.or.dry)) then
            do i = 1,mx
              xtem(i) = btem(i)
            end do
            k = indv
            do j = 1,nw
              sum = 0.
              do i = 1,m
                ix = indx(i,k)
                if (ix.ne.0) then
                  sum = sum + cofw(i,j)*xtem(ix)
                end if
              end do
              cw(j) = sum + cofw(n,j)
            end do
            do j = 1,nw
              cw(j) = amax1(cw(j),0.)
              k = indw(j)
              btem(k) = btem(k) + cw(j)
            end do
          end if
c ...
          jbuf(ipos,jlin,25) = lwflux(btem)
          if (lchoff.ne.0) then
c ...       restore original data
            do j = 1,nc
              btem(j) = ctem(j)
            end do
          end if
          do j = 1,nc
            item(j) = btem(j)*100. + .5
          end do
c ...
          iszn = jbuf(ipos,jlin,3)
          if (iszn.ne.nite) then
            itsol(1) = item(8)
            itsol(2) = item(18)
            itsol(3) = item(19)
            itc4 = irefls(itsol)
            jbuf(ipos,jlin,24) = itc4
          end if
          do i = 1,nc
            jbuf(ipos,jlin,i+3) = item(i)
          end do
  110   continue
  120 continue
      return
      end
