      subroutine msuinw2(iu,nu,idsat)
c ... version of 28.01.93
c ... scalar arguments ..
      integer idsat,iu,nu
c ...
c ... local scalars ..
      real alt,altnom,altsav,ang,c,rad,sctime,sinzen,x
      integer irec,iyyddd,j,jb,jch,jday,jddd,jdispl,jhour,jmin,joff,
     +        jsat,jsec,jspot,jstart,jstop,jtype,jyd,jyear,jyyddd,
     +        kounts,ksat,line,lnode,mask,mtime,n,nbad,nd,nm,nrec,
     +        nscans,ny
      logical badalt
      character*4 cmon
c ...
c ... local arrays ..
      double precision scales(4)
      real cn(4,4),fint(4),satalt(2),slope(4),ylats(11),ylons(11),
     +     zens(11)
      integer indat(100),jbuf(112),jdata(10)
c ...
c ... external functions ..
      real tmpmsu,xfloat
      integer lbyt16_pc,lbyte,lchar_pc,lngtst,mbyt16_pc,nsat1b
      external tmpmsu,xfloat,lbyt16_pc,lbyte,lchar_pc
      external lngtst,mbyt16_pc,nsat1b
c ...
c ... external subroutines ..
      external calday,move
c ...
c ... intrinsic functions ..
      intrinsic abs,atan2,float,iand,mod,sign,sin,sqrt
c ...
c ... statement functions ..
      real arcsin,sine
c ...
c ... data statements ..
      data mask/4095/,satalt/860.,820./
      data scales/4.194304d+6,1.073741823d+9,1.759218604d+13,
     +     7.2057594d+16/
c ...
c ... statement function definitions ..
c ... these are 2**22, 2**30, 2**44, 2**56
      sine(x) = sin(.0174533*x)
      arcsin(x) = 57.29578*atan2(x,sqrt(1.-x*x))
c ...
c ...
      write (*,fmt='(/'' begin global msu 1-b ingest ... '')')
c ... read header record
      irec = 1
      read (iu,rec=irec) indat
      jsat = lchar_pc(1,indat)
      jyear = lbyte(17,7,indat)
      idsat = nsat1b(jsat,jyear)
      if (idsat.eq.1) then
        write (*,fmt='('' *** unrecognized satellite ident '',i4)') jsat
        stop ' *** unrecognized satellite ident *** '
      else
        write (*,fmt='('' data source is satellite number '',i2)') idsat
      end if
      jtype = lchar_pc(2,indat)
      if (jtype.eq.97) go to 110
      if (jtype.eq.98) go to 110
      write (*,fmt='('' *** unrecognized data type '',i3)') jtype
      stop ' *** unrecognized data type *** '
  110 altsav = 0.
      jday = lbyte(24,9,indat)
      jyear = lbyte(17,7,indat)
      jddd = lbyte(24,9,indat)
      jyd = 1000*jyear + jddd
      call calday(jyd,ny,nm,nd,cmon)
      nscans = indat(100)
      ksat = 2 - mod(idsat,2)
      altnom = satalt(ksat)
      nbad = 0
      nrec = 1
      jstart = .001*float(lbyte(38,27,indat)) + .5
      jstop = .001*float(lbyte(102,27,indat)) + .5
      jhour = jstart/3600
      jmin = (jstart-3600*jhour)/60
      jsec = jstart - 3600*jhour - 60*jmin
      write (*,fmt=130) jhour,jmin,jsec,nd,cmon,ny,nscans
  130 format (' msu starting time ',3i3,2x,i3,1x,a4,i3,i6,' scan lines')
      jhour = jstop/3600
      jmin = (jstop-3600*jhour)/60
      jsec = jstop - 3600*jhour - 60*jmin
      write (*,fmt=140) jhour,jmin,jsec
  140 format (6x,' ending time ',3i3,/)
      call move(0,0,jbuf,1,112)
      do 250 line = 1,nscans
        irec = irec + 1
        read (iu,rec=irec) indat
        alt = lbyt16_pc(57,indat)
        if (alt.lt.760. .or. alt.gt.920.) then
          badalt = .true.
          if (nbad.lt.20) write (*,fmt=145) alt,irec
  145     format ('  bad s/c altitude ',g12.5,' in record ',i4)
          nbad = nbad + 1
          if (altsav.ne.0.) then
c ...       replace bad altitude with last good value
            alt = altsav
          else
c ...       replace bad altitude with nominal value
            alt = altnom
          end if
        else
          badalt = .false.
        end if
        if (.not.badalt) altsav = alt
c ...
        do 150 jspot = 1,11
          ang = -47.25 + 9.45*float(jspot-1)
          sinzen = abs((alt+6371.)*sine(ang)/6371.)
          zens(jspot) = arcsin(sinzen)
          jb = 59 + 2* (jspot-1)
          ylats(jspot) = float(mbyt16_pc(jb,indat))/128.
          ylons(jspot) = float(mbyt16_pc(jb+1,indat))/128.
  150   continue
        lnode = 1
        if (lngtst(ylons(1),ylons(6),ylons(11)).eq.0) lnode = -1
        jyear = lbyte(17,7,indat)
        jday = lbyte(24,9,indat)
        jyyddd = 1000*jyear + jday
        mtime = lbyte(38,27,indat)
        sctime = .001*float(mtime)
        if (line.eq.1) then
          iyyddd = jyyddd
          jstart = sctime
        end if
        call move(0,0,jdata,1,10)
        do 160 jch = 1,4
          jb = 9 + 4* (jch-1)
          slope(jch) = xfloat(jb,indat)/scales(2)
          fint(jch) = xfloat(jb+2,indat)/scales(1)
          jdispl = 25 + 8* (jch-1)
          do 160 n = 1,4
            jb = jdispl + 2* (n-1)
  160   cn(n,jch) = xfloat(jb,indat)/scales(n)
        do 240 jspot = 1,11
          jdata(3) = 64.* (sctime+1.893*float(jspot-1))
          jdispl = 8* (jspot-1) + 84
          do 210 j = 1,4
            jb = jdispl + j - 1
            kounts = iand(lbyt16_pc(jb,indat),mask)
c ...       the lead 4 bits of the counts are flag bits of some sort
            if (kounts.eq.mask) go to 240
            c = kounts
c ...       normalize counts
            c = cn(1,j) + c* (cn(2,j)+c* (cn(3,j)+c*cn(4,j)))
            rad = fint(j) + c*slope(j)
            jdata(j+6) = 100.*tmpmsu(rad,j) + .5
  210     continue
          jdata(1) = 65536*line + jspot
          jdata(2) = jyyddd
          jdata(4) = 100.*ylats(jspot) + sign(.5,ylats(jspot))
          jdata(5) = 100.*ylons(jspot) + sign(.5,ylons(jspot))
          joff = (jspot-1)*10
          do 220 j = 1,10
  220     jbuf(j+joff) = jdata(j)
  240   continue
        nrec = nrec + 1
        write (nu,rec=nrec) jbuf
        if (mod(line,25).ne.0) go to 250
        write (*,fmt='('' finished line '',i3)') line
  250 continue
      jdata(1) = idsat
      jdata(2) = nscans
      jdata(6) = jdata(3)
      jdata(3) = lnode
      jdata(4) = 64*jstart
      jdata(5) = iyyddd
      jdata(7) = jyyddd
      jdata(8) = 1
      jdata(9) = 0
      jdata(10) = nscans
      call move(0,0,jbuf,1,112)
      call move(jdata,1,jbuf,1,10)
      write (nu,rec=1) jbuf
      write (*,fmt=270) nscans,nbad
  270 format (' msu ingest completed ... ',i3,
     +       ' scan lines processed; no.bad altitudes = ',i3)
      return
      end
