      subroutine msuprw2(iu,lonfix)
c ... version of 07.05.92
c ... preprocess msu data ... apply antenna gain, limb, and surface-
c ... reflectivity corrections, and longitude-order for
c ... colocation with hirs in 'hirprw'
c ... parameters ..
c
c     Version 2 uses msulc2.f subroutine.  Does byte swapping
c
      integer lmb,lib,mpt,mc,nc,nfv
      parameter (lmb=112,lib=10,mpt=3025,mc=4,nc=mc+1,nfv=11)
c ...
c ... scalar arguments ..
      integer iu,lonfix
c ...
c ... scalars in common ..
      integer lcmoff
c ...
c ... arrays in common ..
      integer jflg(mpt),jlat(mpt),jlon(mpt),jtem(mpt,nc)
c ...
c ... local scalars ..
      integer i,ifail,irec,is,isat,j,jday,jspt,k,lat,lev,line,lon,lss,
     +        lst,misf,mok,msubad,nbad,nsec
c ...
c ... local arrays ..
      integer ibuf(lib,nfv),index(mpt),isort(mpt),ktem(nc),mbuf(lmb)
c ...
c ... external functions ..
      integer lansea
      external lansea
c ...
c ... external subroutines ..
      external iorder,msulc2
c ...
c ... intrinsic functions ..
      intrinsic mod
c ...
c ... common blocks ..
      common /nomlc/lcmoff
      common /ordmsu/jflg,jlat,jlon,jtem
c ...
c ... equivalences ..
      equivalence (ibuf(1,1),mbuf(1))
c ...
c ... data statements ..
      data misf/999999/
c ...
c ... read and decode header record
      irec = 1
      read (iu,rec=irec) mbuf
      isat = mbuf(1)
      nsec = mbuf(2)
      jday = mod(mbuf(5),1000)
      mok = 0
      msubad = 0
      if (nsec.eq.0) stop ' *** no msu data! *** '
      do 100 i = 1,mpt
        jflg(i) = 0
        jlat(i) = misf
        jlon(i) = misf
        do 90 j = 1,nc
   90   jtem(i,j) = misf
  100 continue
c ... main processing loop
      do 180 is = 1,nsec
c ...   read a record (one scan line)
        irec = irec + 1
        read (iu,rec=irec) mbuf
        nbad = 0
        do 170 j = 1,nfv
          if (mok.eq.mpt) go to 190
c ...     process data for each scan spot
          if (ibuf(1,j).eq.0 .or. ibuf(1,j).eq.misf) go to 140
          line = ibuf(1,j)/65536
          jspt = mod(ibuf(1,j),65536)
          do 120 i = 1,mc
            ktem(i) = ibuf(i+6,j)
            if (ktem(i).eq.0 .or. ktem(i).eq.misf) go to 140
  120     continue
          lat = ibuf(4,j)
          lon = ibuf(5,j)
          lst = lansea(lat,lon,lev)
          if (lst.eq.1) go to 130
          if (lat.lt.4500) go to 130
          if (lon.gt.-6000) go to 130
          if (lon.lt.-10500) go to 130
          if (jday.lt.120 .or. jday.gt.315) lst = 1
  130     lss = lst
          call msulc2(ktem,jspt,lst,isat,ifail)
          if (ifail.eq.0) go to 150
  140     nbad = nbad + 1
          go to 170
  150     mok = mok + 1
          if (lcmoff.ne.0) lss = lss*100 + jspt
          jflg(mok) = lss
          jlat(mok) = lat
          jlon(mok) = lon
          do 160 i = 1,nc
  160     jtem(mok,i) = ktem(i)
  170   continue
        if (nbad.eq.0) go to 180
        msubad = msubad + nbad
  180 continue
c ... finished with input ... prepare for output
  190 call iorder(jlon,isort,index,mok,1)
c ... adjust for international date-line if necessary
      lonfix = 0
      if ((isort(1)*isort(mok)).gt.0) go to 197
      if (isort(mok).lt.9000) go to 197
      if (isort(1).gt.-9000) go to 197
      lonfix = 1
      do 193 i = 1,mok
        if (jlon(i).ge.0) go to 193
        jlon(i) = jlon(i) + 36000
  193 continue
      call iorder(jlon,isort,index,mok,1)
  197 continue
      do 200 i = 1,mok
  200 jlon(i) = isort(i)
      do 210 i = 1,mok
  210 isort(i) = jlat(i)
      do 220 i = 1,mok
        j = index(i)
  220 jlat(i) = isort(j)
      do 230 i = 1,mok
  230 isort(i) = jflg(i)
      do 240 i = 1,mok
        j = index(i)
  240 jflg(i) = isort(j)
      do 270 k = 1,nc
        do 250 i = 1,mok
  250   isort(i) = jtem(i,k)
        do 260 i = 1,mok
          j = index(i)
  260   jtem(i,k) = isort(j)
  270 continue
      write (*,fmt=290)
      write (*,fmt=300) mok
      write (*,fmt=310) msubad
      return
  290 format (' msu preprocessing completed ...')
  300 format ('     spots processed ',i4)
  310 format ('     spots unusable  ',i4)
      end
